
; 
;
;                                DETCARD.ASM
;
;              detekce typu videokarty a obsluhovanch videomd
;
;
; 

bit0     EQU       1
bit1     EQU       2
bit2     EQU       4
bit3     EQU       8
bit4     EQU       10h
bit5     EQU       20h
bit6     EQU       40h
bit7     EQU       80h

HI       EQU       256

; -----------------------------------------------------------------------------
;                   definice sel typ videokaret
; -----------------------------------------------------------------------------

CardStru STRUC

; ------ standardn videokarty

CardNul  db        ?                        ; 0: nedetekovno
CardCGA  db        ?                        ; 1: CGA
CardMCGA db        ?                        ; 2: MCGA
CardEGA  db        ?                        ; 3: EGA
CardEG64 db        ?                        ; 4: EGA 64 KB
CardEGAM db        ?                        ; 5: EGA Mono
CardEG6M db        ?                        ; 6: EGA 64 KB Mono
CardHerc db        ?                        ; 7: Hercules
CardVGA  db        ?                        ; 8: VGA
CardVESA db        ?                        ; 9: VESA SVGA (nerozpoznn ip)

CardSVGA EQU       CardVESA+1               ; 10: SVGA zatek definic SVGA

; ------ uren videokarty

CardACUM db        ?                        ; Acumos SuperVGA

CardADVL db        ?                        ; Advance Logic AL2101 SuperVGA

CardAHEA db        ?                        ; AHEAD A SuperVGA
CardAHEB db        ?                        ; AHEAD B SuperVGA

CardATI  db        ?                        ; ATI Technologies SuperVGA 18800
CardATI1 db        ?                        ; ATI Technologies SuperVGA 18800-1
CardATI2 db        ?                        ; ATI Technologies SuperVGA 28800-2
CardATI4 db        ?                        ; ATI Technologies SuperVGA 28800-4
CardATI5 db        ?                        ; ATI Technologies SuperVGA 28800-5

CardCHIP db        ?                        ; Chips & Technologies SVGA 82c451,82c455,82c456
CardCHI1 db        ?                        ; Chips & Technologies SVGA 82c452
CardCHI2 db        ?                        ; Chips & Technologies SVGA 82c453

CardCirr db        ?                        ; Cirrus 5422 SuperVGA

CardEVER db        ?                        ; Everex SuperVGA normal chipset
CardEVE1 db        ?                        ; Everex SuperVGA Ev236 (Trident) UltraGraphics
CardEVE2 db        ?                        ; Everex SuperVGA Ev620 (Trident) Vision VGA
CardEVE3 db        ?                        ; Everex SuperVGA Ev629 (ET4000) ViewPoint TC
CardEVE4 db        ?                        ; Everex SuperVGA Ev673 (Trident) EVGA
CardEVE5 db        ?                        ; Everex SuperVGA Ev678 (Trident) VidewPoint TC

CardGEN1 db        ?                        ; Genoa Systems SuperVGA GVGA 6100
CardGEN2 db        ?                        ; Genoa Systems SuperVGA GVGA 62/300
CardGEN4 db        ?                        ; Genoa Systems SuperVGA GVGA 64/600

CardMXIC db        ?                        ; MXIC 68010 SuperVGA

CardNCR0 db        ?                        ; NCR 77C20/21 SuperVGA
CardNCR2 db        ?                        ; NCR 77C22E SuperVGA

CardOAK  db        ?                        ; OAK Technologies SuperVGA OTI-037C
CardOAK1 db        ?                        ; OAK Technologies SuperVGA OTI-067
CardOAK2 db        ?                        ; OAK Technologies SuperVGA OTI-077

CardPAR  db        ?                        ; Paradise SuperVGA PVGA1A
CardPA00 db        ?                        ; Paradise SuperVGA WD90C00 chipset
CardPA10 db        ?                        ; Paradise SuperVGA WD90C10 chipset
CardPA11 db        ?                        ; Paradise SuperVGA WD90C11 chipset
CardPA20 db        ?                        ; Paradise SuperVGA WD90C20 chipset
CardPA30 db        ?                        ; Paradise SuperVGA WD90C30 chipset
CardPA31 db        ?                        ; Paradise SuperVGA WD90C31 chipset

CardPRIM db        ?                        ; Primus 2000 SuperVGA

CardReal db        ?                        ; RealTek 3106 SuperVGA

CardS911 db        ?                        ; S3 SuperVGA 86c911
CardS924 db        ?                        ; S3 SuperVGA 86c924
CardS801 db        ?                        ; S3 SuperVGA 86c801/86c805
CardS928 db        ?                        ; S3 SuperVGA 86c928

CardTRI8 db        ?                        ; Trident 8800 SuperVGA
CardTRI9 db        ?                        ; Trident 8900 SuperVGA, 9000 SuperVGA

CardET30 db        ?                        ; Tseng Labs ET3000 SuperVGA
                                            ; (Tseng Labs ET4000 SuperVGA):
CardET40 db        ?                        ; Standard Tseng MegaEva/2 ET4000
CardET41 db        ?                        ; Diamond Speedstar 24 ET4000 (24 bit)
CardET42 db        ?                        ; Genoa 7900 ET4000 (24 bit)

CardVID7 db        ?                        ; Video7 SuperVGA

CardStru ENDS

CardNumN EQU       size CardStru            ; poet definovanch videokaret

; -----------------------------------------------------------------------------
;        definice typu VGA DAC (pevodnk na paletu)
; -----------------------------------------------------------------------------

DACTyp0  EQU       0                        ; MONO
DACTyp1  EQU       1                        ; 1 bit, 2 barvy
DACTyp2  EQU       2                        ; 2 bity, 4 barvy CGA
DACTyp4  EQU       3                        ; 4 bity, 16 barev EGA
DACTyp8  EQU       4                        ; 8 bit, 256 barev VGA
DACTyp15 EQU       5                        ; 15 bit, HiColor SVGA
DACTyp16 EQU       6                        ; 16 bit, HiColor SVGA
DACTyp24 EQU       7                        ; 24 bit, TrueColor SVGA
DACTyp32 EQU       8                        ; 32 bit, TrueColor SVGA

; -----------------------------------------------------------------------------
;        ostatn konstanty
; -----------------------------------------------------------------------------

;CRTC     EQU       3D4h                     ; adresa adie CRTC - barevn
;CRTCM    EQU       3B4h                     ; adresa adie CRTC - MONO


Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

Start:   mov       ax,offset Code:DataBeg + 0fh
         mov       cl,4
         shr       ax,cl
         mov       bx,cs
         add       ax,bx
         mov       ds,ax                    ; DS <- datov segment


         call      DetSVGA
         jnc       Start1
         xor       ax,ax

Start1:  mov       si,offset TDefCard

;         mov       ax,CardEnds

         or        ax,ax
         jz        Start3

Start2:  mov       si,cs:[si]
         dec       ax
         jnz       Start2

Start3:  inc       si
         inc       si
         mov       cl,cs:[si]
         mov       ch,0

Start4:  inc       si
         mov       dl,cs:[si]
         mov       ah,2
         int       21h
         loop      Start4


         int       20h











; 
;
;                          Obslun procedury
;
; 



; *****************************************************************************
;                              Int10P
;                obsluha INT 10h s schovou registr
; -----------------------------------------------------------------------------
;
; *****************************************************************************

Int10P   PROC      NEAR

         pushf
         push      si
         push      di
         push      bp
         push      ds
         push      es

         int       10h

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         popf
         ret

Int10P   ENDP

; 
;
;                             Detekce videokaret
;
; 
;



; *****************************************************************************
;                              DetSVGA
;                       detekce videokarty SVGA
; -----------------------------------------------------------------------------
; VSTUP: DS=datov segment
; VSTUP: CY=nenalezena
;         AX=identifikan kd karty
;         BX=velikost videopamti
; *****************************************************************************

DetSVGA  PROC      NEAR

         push      cx
         push      si
         push      di
         push      es

; ------ proven struktury tabulky

         mov       si,offset TDefCard
         xor       ax,ax                    ; ukazatel sla karty
         mov       ch,0
DetSVGA1:mov       di,si                    ; zatek definice karty
         mov       si,cs:[di]               ; adresa definice dal karty
         inc       di
         inc       di
         mov       cl,cs:[di]               ; dlka textu nzvu karty
         inc       di
         add       di,cx                    ; peskoen textu nzvu
         mov       cl,cs:[di]               ; dlka textu hledacho textu
         inc       di
         add       di,cx                    ; peskoen hledacho textu
         add       di,2                     ; peskoen adresy obsluhy testu
         cmp       di,si                    ; souhlas ?
         jne       DetSVGA2

         inc       ax
         cmp       ax,CardNumN
         jb        DetSVGA1
         xor       ax,ax
         cmp       si,offset TDefCrd0       ; je konec tabulky ?
DetSVGA2:clc
         jne       DetSVGA9

; ------ vyhledn karty SVGA testem etzce i port

         mov       cx,CardSVGA-1            ; ukazatel sla karty
DetSVGA3:inc       cx                       ; zven ukazatele sla karty
         call      GetPCard                 ; pprava parametr dal karty
         jc        DetSVGA4                 ; karta nenalezena
         call      TestCSrc                 ; test vyhlednm etzce
         jc        DetSVGA3                 ; nenalezen - dal karta
         call      TestCPrt                 ; test port karty
         jc        DetSVGA3                 ; nenalezen -> AX=slo karty
         jmp       short DetSVGA9           ; souhlas test etzce i port

; ------ vyhledn karty SVGA testem jen port

DetSVGA4:mov       cx,CardSVGA-1
DetSVG42:inc       cx                       ; zven ukazatele sla karty
         call      GetPCard                 ; pprava parametr dal karty
         jc        DetSVGA5                 ; karta nenalezena
         call      TestCPrt                 ; test port karty
         jc        DetSVG42                 ; nenalezen -> AX=slo karty
         jmp       short DetSVGA9           ; souhlas test port

; ------ vyhledn karty SVGA testem jen etzce

DetSVGA5:mov       cx,CardSVGA-1            ; ukazatel sla karty
DetSVG52:inc       cx                       ; zven ukazatele sla karty
         call      GetPCard                 ; pprava parametr dal karty
         jc        DetSVGA6                 ; karta nenalezena
         call      TestCSrc                 ; test vyhlednm etzce
         jc        DetSVG52                 ; nenalezen - dal karta

         xchg      ax,cx                    ; AX <- slo nalezen videokarty
         mov       bx,256                   ; zejm bude 256 KB pamti

DetSVGA6:

DetSVGA9:pop       es
         pop       di
         pop       si
         pop       cx
         ret

DetSVGA  ENDP

; *****************************************************************************
;                                TestCSrc
;                   test aktivn karty vyhlednm etzce
; -----------------------------------------------------------------------------
; VSTUP: DS=datov segment
; VSTUP: CY=nen etzec
; *****************************************************************************

TestCSrc PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      si
         push      di
         push      ds
         push      es

; ------ test, zda m bt etzec vyhledvn

         mov       di,ds:[ACardSrc]         ; adresa vyhledvacho etzce
         push      cs
         pop       es                       ; ES <- segment definin tabulky
         mov       cl,es:[di]               ; dlka etzce
         mov       ch,0
         inc       di                       ; zatek textu k vyhledn
         jcxz      TestCSr8                 ; nen etzec k vyhledn

; ------ pprava parametr

         mov       ax,0c000h                ; segment BIOS
         mov       ds,ax                    ; DS <- segment BIOS
         xor       si,si                    ; vyhledvac adresa
         cld

; ------ porovnn etzce na jedn adrese

TestCSr2:push      si
         push      di
         push      cx

TestCSr3:lodsb                              ; naten znaku z BIOS
         cmp       al,"a"
         jb        TestCSr4
         cmp       al,"z"
         ja        TestCSr4
         sub       al,32                    ; konverze na velk psmeno
TestCSr4:scasb                              ; porovnn s referennm textem
         loope     TestCSr3                 ; pi shod dal znak

         pop       cx
         pop       di
         pop       si
         je        TestCSr9                 ; etzec nalezen OK

; ------ pprava pro dal adresu

         inc       si                       ; zven adresy v BIOS
         cmp       si,400h                  ; asi tak maximln adresa
         jb        TestCSr2                 ; test dal adresy

TestCSr8:stc                                ; pznak nenalezen etzce

; ------ nvrat registr

TestCSr9:pop       es
         pop       ds
         pop       di
         pop       si
         pop       cx
         pop       ax
         ret

TestCSrc ENDP

; *****************************************************************************
;                               TestCPrt
;                      test aktivn karty testem port
; -----------------------------------------------------------------------------
; VSTUP: DS=datov segment
; VSTUP: CY=karta nesouhlas
;         AX=identifikan slo karty
;         BX=velikost videopamti v KB
; *****************************************************************************

TestCPrt PROC      NEAR

; ------ schova registr

         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es

; ------ test, zda se provd test

         cmp       word ptr ds:[ACardTst],1 ; provd se test ?
         jb        TestCPr9                 ; test se neprovd
         call      word ptr ds:[ACardTst]   ; proveden testu videokarty

; ------ nvrat registr

TestCPr9:pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         ret

TestCPrt ENDP

; *****************************************************************************
;                               GetPCard
;                      poskytnut parametr karty
; -----------------------------------------------------------------------------
; VSTUP: CX=slo videokarty
;        DS=datov segment
; VSTUP: CY=neplatn slo videokarty
; *****************************************************************************

GetPCard PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      si

; ------ kontrola sla videokarty

         cmp       cx,CardNumN-1            ; kontrola maximlnho sla
         cmc
         jc        GetPCar9                 ; neplatn slo karty

; ------ vyhledn definice karty

         mov       si,offset TDefCard       ; tabulka definic karet
         jcxz      GetPCar2                 ; je karta 0
GetPCar1:mov       si,cs:[si]               ; adresa definice dal karty
         loop      GetPCar1                 ; nalezen definice karty

; ------ uloen adresy definic

GetPCar2:inc       si
         inc       si                       ; peskoen adresy dal karty
         mov       ds:[ACardNam],si         ; adresa jmna karty

         mov       al,cs:[si]               ; dlka textu jmna karty
         inc       si
         mov       ah,0
         add       si,ax                    ; peskoen jmna karty
         mov       ds:[ACardSrc],si         ; adresa vyhledvacho etzce

         mov       al,cs:[si]               ; dlka vyhledvacho etzce
         inc       si
         add       si,ax                    ; peskoen vyhledvacho etzce
         mov       ax,cs:[si]
         mov       ds:[ACardTst],ax         ; adresa obsluhy testu karty

; ------ nvrat registr

         clc                                ; pznak platnho sla karty
GetPCar9:pop       si
         pop       cx
         pop       ax
         ret

GetPCard ENDP

; *****************************************************************************
;                             TestVESA
;                        test ovladae VESA
; -----------------------------------------------------------------------------
; VSTUP: DS=datov segment
; VSTUP: CY=nen ovlada VESA
; *****************************************************************************

TestVESA PROC      NEAR

; ------ naten informac VESA

         push      ds
         pop       es                       ; ES <- datov segment
         mov       di,offset VesaInfo       ; DI <- buffer informac VESA
         mov       ax,4f00h
         call      Int10P                   ; test ovladae VESA

; ------ test navrcenho stavu

         cmp       ax,4fh
         jne       TestVES8                 ; nen VESA
         cmp       word ptr es:[di],"EV"
         jne       TestVES8                 ; nen VESA
         cmp       word ptr es:[di+2],"AS"
         jne       TestVES8


         jmp       short TestVES9

;; We have a VESA compatible SuperVGA, so determine how much memory must
;; be on the video board by finding the amount of memory used by the
;; highest resolution video mode supported.
;;
;; At the same time initialise the table of valid video modes for this
;; SuperVGA, and bytes per line values for the video mode.
;
;        push    ds
;        push    bp
;        mov     ax,[WORD es:di+16]
;        mov     ds,ax
;        mov     bp,[WORD es:di+14]  ; DS:BP -> List of valid VESA modes
;        mov si,offset AllVesaModes
;        mov     bx,offset VesaModes
;        cld
;
;@@VesaMemLoop:
;        lods    [WORD cs:si]        ; Load VESA mode number
;        mov     cx,ax
;        jcxz    @@EndVESA           ; Finished when mode number is zero
;        lods    [WORD cs:si]        ; Load amount of memory required for mode
;        push    ax          ;   and save on stack
;        lods    [WORD cs:si]        ; Load MGL video mode number
;        push    ax                  ;   and save on stack
;
;; First check to see if the mode is a valid VESA mode.
;
;        mov     di,bp               ; DS:DI -> mode list
;@@CheckMode:
;        mov     ax,[WORD ds:di]
;        inc     di
;        inc     di
;        cmp     ax,-1
;        je      @@NotFound
;        cmp     ax,cx
;        je      @@FoundMode         ; Yes mode was found
;        jmp     @@CheckMode         ; Loop for all valid modes
;
;@@NotFound:
;        pop     ax                  ; Restore stack
;        pop     ax
;        jmp     @@VesaMemLoop       ; Continue loop
;
;@@FoundMode:
;        mov     ax,seg VesaBuf
;        mov     es,ax
;        mov     di,offset VesaBuf
;        mov     ax,4F01h            ; AX := Query Mode Information
;        int     10h
;        pop     dx                  ; DX := MGL Mode Number
;        pop     cx                  ; CX := Video memory required
;        or      ah,ah
;        jnz     @@VesaMemLoop       ; Mode not supported, try next one
;        test    [BYTE es:di],1
;        jz      @@VesaMemLoop       ; Mode not supported, try next one
;
;; Video mode is supported, so add to mode table.
;
;        push    bx
;        mov     bx,[WORD es:di+16]
;        mov     ax,dx
;        call    setBytesPerLine     ; Set the bytes per line value for mode
;        pop     bx
;        mov     [BYTE cs:bx],dl     ; Store the mode number
;        inc     bx
;
;        cmp     cx,[WORD VideoMem]
;        jle     @@VesaMemLoop       ; Memory is less, try next mode
;        mov     [WORD VideoMem],cx  ; Increase the memory size
;        jmp     @@VesaMemLoop
;
;@@EndVESA:
;        pop     bp
;        pop     ds
;        call    checkVESAPageFlip   ; Does VESA support page flipping?
;        jc      @@NoFlip
;        mov     [PageFlip],true
;
;@@NoFlip:
;        mov     [WORD VideoModes],offset VesaModes
;        mov     ax,grSVGA
;        stc
;        ret
;
;@@NoVESA:
;        clc
;        ret
;
;ENDP    FindVESA
;

TestVES8:stc
TestVES9:mov       ax,CardVESA              ; identifiktor VESA
         ret

TestVESA ENDP

; *****************************************************************************
;                                 TestS3
;                           test karty S3 SVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta S3 SVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestS3   PROC      NEAR

; ------ schova zmku registr

         mov       dx,3d4h
         mov       ah,38h
         call      ReadIPrt                 ; ten zmku registr
         mov       ch,al                    ; CH <- schova zmku

; ------ uzamen registr

         mov       al,0
         call      WritIPrt                 ; uzamen registr

; ------ test registr - nesm bt modifikovateln

         mov       ax,35h*HI + bit0+bit1+bit2+bit3
         call      TestIPrt                 ; test registru
         cmc
         jc        TestS39                  ; nen S3 SVGA

; ------ odemknut registr

         mov       ax,38h*HI + 48h
         call      WritIPrt                 ; odemknut registr

; ------ test registr - mus bt modifikovateln

         mov       ax,35h*HI + bit0+bit1+bit2+bit3
         call      TestIPrt                 ; test registru
         jc        TestS39                  ; nen S3 SVGA

; ------ detekce typu ipu S3 SVGA -> BX

         mov       ah,30h
         call      ReadIPrt                 ; ten sla verze ipu
         mov       bx,CardS928              ; identifiktor S3 SVGA 86c928
         cmp       al,90h
         je        TestS32                  ; je S3 SVGA 86c928
         mov       bx,CardS801              ; identifiktor S3 SVGA 86c801/805
         cmp       al,0a0h
         je        TestS32                  ; je S3 SVGA 86c801/805
         mov       bx,CardS924              ; identifiktor S3 SVGA 86c924
         cmp       al,82h
         je        TestS32                  ; je S3 SVGA 86c924
         mov       bx,CardS911              ; jinak je S3 SVGA 86c911

; ------ detekce velikosti videopamti

TestS32: push      bx                       ; identifiktor karty
         mov       ah,36h
         call      ReadIPrt                 ; ten registru velikosti pamti
         mov       cl,5
         shr       al,cl                    ; rotace na pozici

         cmp       bx,CardS911
         je        TestS34                  ; je S3 SVGA 86c911
         cmp       bx,CardS924
         je        TestS34                  ; je S3 SVGA 86c924

; ------ velikost pamti pro 86c801/86c805/86c928

         mov       bx,512                   ; 512 KB pamti
         cmp       al,7
         je        TestS36
         shl       bx,1                     ; 1 MB pamti
         cmp       al,6
         je        TestS36
         shl       bx,1                     ; 2 MB pamti
         cmp       al,4
         je        TestS36
         mov       bx,3072                  ; 3 MB pamti
         cmp       al,2
         je        TestS36
         mov       bx,4096                  ; jinak 4 MB pamti
         jmp       short TestS36

; ------ velikost pamti pro 86c911/86c924

TestS34: mov       bx,512                   ; 512 KB pamti
         test      al,bit0
         jnz       TestS36
         shl       bx,1                     ; jinak 1 MB pamti
TestS36: pop       ax                       ; identifiktor S3 SVGA
         clc                                ; pznak operace OK

; ------ nvrat registru zmku (DX=3d4h)

TestS39: pushf
         push      ax
         mov       ah,38h
         mov       al,ch
         call      WritIPrt                 ; nvrat registru zmku
         pop       ax
         popf
         ret

TestS3   ENDP

; *****************************************************************************
;                                 TestATI
;                      test karty ATI Technologies SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta ATI Technologies SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestATI  PROC      NEAR

; ------ detekce podle pamti BIOS

         mov       ax,0c000h
         mov       es,ax
         cmp       word ptr es:[40h],"13"   ; identifikace "ATI" pro VGA
         jne       TestATI2                 ; nen ATI Technologies SuperVGA

; ------ kontrola etzce "761295520"

         mov       bx,31h
         cmp       word ptr es:[bx],"67"
         jne       TestATI2
         cmp       word ptr es:[bx+2],"21"
         jne       TestATI2
         cmp       word ptr es:[bx+4],"59"
         jne       TestATI2
         cmp       word ptr es:[bx+6],"25"
         jne       TestATI2
         cmp       byte ptr es:[bx+8],"0"
TestATI2:stc
         jne       TestATI9

; ------ detekce verze ipu ATI 18800 nebo 18800-1

         mov       ch,es:[43h]              ; verze ipu ATI
         cmp       ch,"3"
         jae       TestATI4                 ; je vy verze ipu

         mov       ax,CardATI1              ; je ATI Technologies SVGA 18800-1
         cmp       ch,"1"
         jne       TestATI3
         mov       ax,CardATI               ; je ATI Technologies SuperVGA 18800

; ------ detekce velikosti pamti pro 18800 a 18800-1

TestATI3:push      ax
         mov       ah,0bbh
         mov       dx,1ceh
         call      ReadIPrt                 ; ten velikosti pamti
         mov       bx,256                   ; 256 KB videopamti
         test      al,20h                   ; je 256 KB pamti ?
         pop       ax
         jz        TestATI7                 ; je 256 KB pamti
         shl       bx,1                     ; 512 KB pamti
         jmp       short TestATI7

; ------ detekce velikosti pamti pro 28800-2, 28800-4 a 28800-5

TestATI4:mov       dx,1ceh
         mov       ah,0b0h
         call      ReadIPrt                 ; ten velikosti pamti
         mov       bx,256                   ; 256 KB videopamti
         test      al,10h                   ; je 256 KB pamti ?
         jz        TestATI5                 ; je 256 KB pamti
         shl       bx,1                     ; je 512 KB pamti
TestATI5:mov       cl,al                    ; CL <- schova bajtu

; ------ detekce verze ipu ATI 28800-2, 28800-4 nebo 28800-5

         mov       ax,CardATI2              ; ATI Technologies SVGA 28800-2
         cmp       ch,"4"
         jb        TestATI7                 ; je ATI Technologies SVGA 28800-2
         mov       ax,CardATI4              ; ATI Technologies SVGA 28800-4
         je        TestATI6                 ; je ATI Technologies SVGA 28800-4
         mov       ax,CardATI5              ; ATI Technologies SVGA 28800-5

; ------ upesnn velikosti pamti pro 28800-4 a 28800-5

TestATI6:test      cl,bit3                  ; upesnn velikosti pamti
         jz        TestATI7                 ; nen 1 MB pamti
         mov       bx,1024                  ; je 1 MB pamti
TestATI7:clc                                ; pznak platnosti karty

TestATI9:ret

TestATI  ENDP

; *****************************************************************************
;                                 TestNCR
;                      test karty NCR 77C22E SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta NCR 77C22E SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestNCR  PROC      NEAR

; ------ schova registru rozenho mdu

         mov       dx,3c4h
         mov       ah,5                     ; index
         call      ReadIPrt                 ; ten registru
         mov       ch,al                    ; CH <- schova registru

; ------ test registru rozenho mdu

         mov       al,bit0+bit2             ; AL <- maska
         call      TestIPrt                 ; test registru
         jc        TestNCR9                 ; nen karta NCR 77C22E SuperVGA

; ------ zkaz registr

         mov       al,0
         call      WritIPrt                 ; zkaz registr

; ------ test registr - nesm bt zapisovateln

         mov       ax,10h*HI + 0ffh
         call      TestIPrt                 ; nesm bt zpis
         cmc
         jc        TestNCR9                 ; lze zapisovat - neplat

; ------ povolen registr

         mov       ax,5*HI + 1              ; AH <- index, AL <- hodnota
         call      WritIPrt                 ; povolen registr

; ------ test registr - te mus bt modifikovateln

         mov       ax,10h*HI + 0ffh
         call      TestIPrt                 ; test registru
         jc        TestNCR9                 ; nelze zapisovat - chyba

; ------ detekce verze ipu

         mov       ah,8                     ; index
         call      ReadIPrt                 ; ten verze ipu
         mov       cl,4
         shr       al,cl
         cmp       al,2
         mov       ax,CardNCR0              ; identifikace NCR77C20/21
         jb        TestNCR2                 ; je NCR77C20/21
         mov       ax,CardNCR2              ; identifikace NCR77C22

; ------ nastaven videomdu

TestNCR2:push      ax
         mov       ax,5eh
         call      Int10P                   ; nastaven videomdu 640x400/256

; ------ detekce velikosti videopamti

         mov       bx,4096                  ; maximln 4 MB videopamti
         mov       dx,offset BankNCR        ; obsluha pepnn banky
         call      TestMem                  ; detekce velikosti videopamti
         pop       ax
                                          ;* zde je CY = chyba pamti
; ------ nvrat registru rozenho mdu

TestNCR9:pushf
         push      ax
         mov       ah,5                     ; index
         mov       al,ch                    ; pvodn hodnota
         mov       dx,3c4h
         call      WritIPrt                 ; nvrat registru
         pop       ax
         popf
         ret

TestNCR  ENDP

; *****************************************************************************
;                                 TestTri
;                      test karty Trident SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Trident SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestTri  PROC      NEAR

; Pozn.: Nkter star verze Trident nesnej pstup na port "star definice"
;        16 bit, mus se provdt 8-bitov. Test popisovan v VGADOC (zpis
;        vzorku do registu volby banky) zpsobuje u nkterch TVGA havrii.
;        Zd se, e problm odstran resetovn karty nastavenm videomdu
;        ped pepnutm banky.

; ------ nastaven star definice

         mov       dx,3c4h
         mov       al,0bh
         out       dx,al                    ; index 0Bh
         inc       dx
         mov       al,0
         out       dx,al                    ; nastaven star definice

; ------ detekce karty Trident SuperVGA

         in        al,dx                    ; nastaven nov definice
         and       al,0fh
         cmp       al,2
         jb        TestTri9                 ; nen Trident SuperVGA
         je        TestTri4                 ; je Trident 8800

; ------ je Trident 8900/9000 - detekce velikosti pamti

         mov       dl,0d4h                  ; port 3D4h
         mov       ah,1fh                   ; registr pamti
         call      ReadIPrt                 ; ten registu pamti
         and       al,bit0+bit1
         mov       bx,256                   ; je 256 KB pamti
         cmp       al,1
         jb        TestTri2                 ; je 256 KB pamti
         shl       bx,1                     ; 512 KB pamti
         cmp       al,3
         jb        TestTri2                 ; je 512 KB pamti
         shl       bx,1                     ; 1 MB pamti
TestTri2:mov       ax,CardTri9              ; identifikace Trident 8900
         jmp       short TestTri6

; ------ je Trident 8800 - detekce velikosti pamti

TestTri4:mov       ah,1fh                   ; registr pamti
         mov       dl,0d4h                  ; port 3D4h
         call      ReadIPrt                 ; ten registru pamti
         mov       bx,256                   ; je 256 KB pamti
         and       al,bit1
         jz        TestTri5                 ; je 256 KB pamti
         shl       bx,1                     ; je 512 KB pamti
TestTri5:mov       ax,CardTri8              ; identifikace Trident 8800
TestTri6:clc                                ; pznak operace OK

TestTri9:ret

TestTri  ENDP

; *****************************************************************************
;                                 TestVID
;                      test karty Video7 SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Video7 SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestVID  PROC      NEAR

; ------ detekce videokarty

         mov       ax,6f00h
         xor       bx,bx
         call      Int10P
         cmp       bx,"V7"
         stc                                ; pznak chyby
         jne       TestVID9                 ; nen Video7 SuperVGA

; ------ detekce velikosti videopamti

         mov       ax,6f07h
         call      Int10P
         and       ah,7fh
         mov       bx,256                   ; je 256 KB pamti
         cmp       ah,2
         jb        TestVID2                 ; je 256 KB videopamti
         shl       bx,1                     ; je 512 KB pamti
         cmp       ah,4
         jb        TestVID2                 ; je 512 KB pamti
         shl       bx,1                     ; je 1 MB pamti

TestVID2:mov       ax,CardVID7              ; identifiktor karty
         clc                                ; pznak operace OK
TestVID9:ret

TestVID  ENDP

; *****************************************************************************
;                                 TestGENO
;                      test karty Genoa GVGA SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Genoa GVGA SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestGENO PROC      NEAR

; ------ test identifikace v pamti

         mov       ax,0c000h
         mov       es,ax                    ; ES <- segment pamti BIOS SVGA
         mov       bx,es:[37h]              ; offset informan tabulky
         cmp       byte ptr es:[bx],77h     ; je GENOA ?
         jne       TestGEN8                 ; nen GENOA
         cmp       word ptr es:[bx+2],6699h
         jne       TestGEN8                 ; nen GENOA

; ------ rozlien varianty GENOA

         mov       cl,es:[bx+1]             ; slo varianty karty
         mov       bx,256                   ; je 256 KB videopamti
         mov       ax,CardGEN2              ; identifikace GENOA 62/300
         or        cl,cl
         jz        TestGEN9                 ; je GENOA 62/300
         mov       ax,CardGEN1
         cmp       cl,22h
         je        TestGEN9                 ; je GENOA 6100
         shl       bx,1                     ; je 512 KB videopamti
         mov       ax,CardGEN4
         cmp       cl,11h
         je        TestGEN9                 ; je GENOA 64/600
TestGEN8:stc                                ; pznak neplatn karty
TestGEN9:ret

TestGENO ENDP

; *****************************************************************************
;                                 TestPAR
;                      test karty Paradise SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Paradise SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestPAR  PROC      NEAR

; ------ schova registru zmku (b0 a b2: 5=odemknut R9 a R0D)

         mov       dx,3ceh
         mov       ah,0fh
         call      ReadIPrt                 ; ten registru zmku
         mov       ch,al                    ; CH <- schova registru

; ------ uzamen registr 9 a 0D (pro ten i zpis)

         and       al,not bit0+bit1+bit2+bit4 ; nulovn bit
         call      WritIPrt                 ; zpis - uzamen registr

; ------ test modifikace registru volby banky (nesm bt mniteln)

         mov       ax,9*HI + 7fh            ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru volby banky
         jnc       TestPAR2                 ; je mniteln - chyba

; ------ odemknut registr 9 a 0D

         mov       ax,0fh*HI + 5            ; AH <- index, AL <- hodnota
         call      WritIPrt                 ; odemknut registr

; ------ test modifikace registru volby banky (mus bt mniteln)

         mov       ax,9*HI + 7fh            ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru volby banky
         jnc       TestPAR3                 ; je karta OK
TestPAR2:stc                                ; pznak chyby karty
         jmp       TestPAR9                 ; nen mniteln - chyba

; ====== je Paradise SVGA - detekce ipu PVGA1A

; ------ schova registru zmku WD90Cxx (b0 a b2: 5=odemknut R2A a R30)

TestPAR3:mov       dl,0d4h                  ; port 3D4h
         mov       ah,29h
         call      ReadIPrt                 ; naten stavu registru
         mov       cl,al                    ; CL <- schova registru zmku

; ------ odemknut registru zmku WD90Cxx

         and       al,not bit0+bit1+bit2+bit3 ; zpis povolen
         or        al,5+bit7                ; ten povoleno
         call      WritIPrt                 ; odemknut registr

; ------ test registru "scratch" WD90Cxx

         mov       ax,2bh*HI + 0ffh         ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru "scratch"

; ------ nvrat registru zmku WD90Cxx

         pushf
         mov       ah,29h                   ; registr zmku
         mov       al,cl                    ; pvodn hodnota registru
         call      WritIPrt                 ; nvrat obsahu registru zmku
         popf
         mov       ax,CardPAR               ; identifiktor PVGA1A
         jc        TestPAR7                 ; chyba - je karta PVGA1

; ====== je WD90Cxx - detekce ipu

; ------ schova registru 6 karty WD90C1x

         mov       dl,0c4h                  ; port 3C4h
         mov       ah,6                     ; index
         call      ReadIPrt                 ; ten registru
         mov       cl,al                    ; CL <- schova registru 6

; ------ odemknut registr WD90C1x

         mov       al,48h
         call      WritIPrt                 ; odemknut registr

; ------ test registru 7 "scratch"

         mov       ax,7*HI + bit4+bit5+bit6+bit7 ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru
         mov       ax,CardPA00              ; identifiktor WD90C00
         jc        TestPAR6                 ; je WD90C00

; ------ test, zda je WD90C2x

         mov       ax,10h*HI + 0ffh
         call      TestIPrt
         mov       ax,CardPA20              ; identifiktor WD90C20
         jc        TestPAR6                 ; je ip WD90C2x

; ------ test, zda je WD90C1x

         mov       ax,14h*HI + bit0+bit1+bit2+bit3
         call      TestIPrt                 ; test portu
         jc        TestPAR4                 ; je ip WD90C1x

; ------ je WD90C3x - rozlien varianty

         mov       dl,0d4h                  ; port 3D4h
         mov       ah,37h                   ; index
         call      ReadIPrt                 ; ten registru
         cmp       al,"1"                   ; je WD90C31 ?
         mov       ax,CardPA31              ; identifiktor ipu WD90C31
         je        TestPAR6                 ; je WD90C31
         mov       ax,CardPA30              ; identifiktor ipu WD90C30
         jmp       short TestPAR6

; ------ je ip WD90C1x - rozlien varianty (registr interface pamti)
;!!!! (kter registr plat ? - 10h nebo 0Ah)
TestPAR4:
         mov       ax,10h*HI + bit2         ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru
         jnc       TestPAR5
;!!!!!
         mov       ax,0Ah*HI + bit2         ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru
         mov       ax,CardPA10              ; identifiktor WD90C10
         jc        TestPAR6                 ; je WD90C10
TestPAR5:mov       ax,CardPA11              ; jinak je WD90C11

; ------ nvrat registru 6

TestPAR6:push      ax
         mov       dl,0c4h                  ; port 3C4h
         mov       ah,6                     ; index
         mov       al,cl                    ; AL <- pvodn obsah
         call      WritIPrt                 ; nvrat registru
         pop       ax

; ------ detekce velikosti videopamti (AX=identifiktor) -> BX

TestPAR7:push      ax
         mov       dl,0ceh                  ; port 3CEh
         mov       ah,0bh                   ; index
         call      ReadIPrt                 ; ten registru pamti
         mov       cl,6
         shr       al,cl                    ; rotace na pozici
         mov       bx,256                   ; 256 KB pamti
         cmp       al,2
         jb        TestPAR8                 ; je 256 KB videopamti
         mov       bh,512/HI                ; 512 KB pamti
         je        TestPAR8                 ; je 512 KB pamti
         mov       bh,1024/HI               ; 1 MB pamti
TestPAR8:pop       ax
         clc                                ; pznak operace OK

; ------ nvrat registu zmku 0fh

TestPAR9:pushf
         push      ax
         mov       dl,0ceh                  ; port 3CEh
         mov       ah,0fh
         mov       al,ch                    ; uschovan stav
         call      WritIPrt                 ; nvrat registru zmku
         pop       ax
         popf
         ret

TestPAR  ENDP

; *****************************************************************************
;                                 TestCHIP
;                   test karty Chips & Technologies SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Chips & Technologies SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestChip PROC      NEAR

; ------ detekce karty Chips & Technologies SuperVGA

         mov       ax,5f00h
         xor       bx,bx
         call      Int10P                   ; detekce karty
         cmp       al,5fh                   ; je Chips & Technologies SuperVGA ?
         stc                                ; pznak neplatn karty
         jne       TestChi9                 ; nen Chips & Technologies SuperVGA

; ------ upesnn verze ipu

         mov       cl,4
         shr       bl,cl
         mov       ax,CardCHIP              ; ip  82c451
         jz        TestChi4                 ; 0 = je ip 82c451
         cmp       bl,2
         je        TestChi4                 ; 2 = je ip 82c455 (jako 82c451)
         cmp       bl,4
         je        TestChi4                 ; 4 = je ip 82c456 (jako 82c451)

         mov       ax,CardCHI1              ; ip 82c452
         cmp       bl,1
         je        TestChi4                 ; 1 = je ip 82c452

         mov       ax,CardCHI2              ; jinak ip 82c453 a vy

; ------ velikost videopamti

TestChi4:mov       cl,bh                    ; CL <- velikost videopamti
         mov       bx,256                   ; 256 KB videopamti
         shl       bx,cl                    ; velikost videopamti
         clc                                ; pznak operace OK
TestChi9:ret

TestChip ENDP

; *****************************************************************************
;                                 TestET30
;                       test karty ET3000/ET4000 SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta ET3000/ET4000 SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestET30 PROC      NEAR

; ------ povolen rozenho mdu ET4000

         mov       dx,3bfh
         mov       al,3
         out       dx,al

         mov       dl,0d8h                  ; port 3D8h
         mov       al,0a0h
         out       dx,al                    ; povolen rozenho mdu ET4000

; ------ test registru pepnn banky

         mov       dl,0cdh                  ; port 3CDh
         mov       al,3fh                   ; maska
         call      TestPort                 ; test portu volby banky
         jc        TestET39                 ; nen karta ET3000/ET4000 SuperVGA

; ------ detekce karty ET4000 - test registru rozen poten adresy

         mov       dl,0d4h                  ; port 3D4h
         mov       ax,33h*HI + bit0+bit1+bit2+bit3 ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru rozen adresy
         jnc       TestET32                 ; je platn - je karta ET4000

; ------ nastaven videomdu pro kartu ET3000

         mov       ax,2dh
         call      Int10P                   ; videomd 640x350/256

; ------ detekce velikosti pamti pro ET3000

         mov       bx,512                   ; maximln 512 KB videopamti
         mov       dx,offset BankET30       ; obsluha pepnn banky
         call      TestMem                  ; detekce velikosti videopamti
         mov       ax,CardET30              ; je karta ET3000 SuperVGA
         jmp       short TestET39           ; CY=chyba pamti

; ------ detekce velikosti pamti pro ET4000

TestET32:mov       ah,37h                   ; index (port = 3D4h)
         call      ReadIPrt                 ; ten registru pamti
         and       al,bit0+bit1+bit7        ; bity velikosti pamti
         mov       bx,256                   ; 256 KB videopamti
         cmp       al,bit1+bit7             ; je 256 KB pamti ?
         jb        TestET34                 ; je 256 KB pamti
         mov       bh,512/HI                ; 512 KB videopamti
         je        TestET34                 ; je 512 KB pamti
         mov       bh,1024/HI               ; jinak 1024 KB pamti

; ------ detekce videokarty Diamond Speedstar 24

TestET34:push      bx
         mov       ax,10e0h
         mov       bx,2eh OR 80h
         call      Int10P                   ; nastaven videomdu
         pop       bx
         cmp       ax,10h                   ; videomd nastaven ?
         mov       ax,CardET41              ; identifiktor karty Speedstar
         je        TestET36                 ; je Diamond Speedstar 24

; ------ detekce videokarty Genoa 7900

         push      bx
         mov       ax,10f0h
         mov       bx,3eh OR 80h
         call      Int10P                   ; nastaven videomdu
         pop       bx
         cmp       ax,10h                   ; videomd nastaven OK
         mov       ax,CardET42              ; identifiktor karty Genoa
         je        TestET36                 ; je Genoa 7900

; ------ jinak je videokarta MegaEga

         mov       ax,CardET40              ; je MegaEga
TestET36:clc                                ; pznak
TestET39:ret

TestET30 ENDP

; *****************************************************************************
;                                 TestEVER
;                       test karty Everex SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Everex SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestEVER PROC      NEAR

; ------ poskytnut informac o kart Everex SuperVGA

         mov       ax,7000h
         xor       bx,bx
         call      Int10P                   ; detekce parametr
         cmp       al,70h                   ; je karta Everex SuperVGA ?
         stc                                ; pznak, e nen Everex SuperVGA
         jne       TestEVE9                 ; nen karta Everex SuperVGA

; ------ rozlien typu ipu videokarty

         mov       cl,4                     ; poet rotac
         shr       dx,cl                    ; identifikan slo ipu

; ------ karta UltraGraphics - ip Trident 236

         mov       ax,CardEVE1
         cmp       dx,236h
         je        TestEVE2                 ; je ip Trident 236

; ------ karta Vision VGA - ip Trident 620

         mov       ax,CardEVE2
         cmp       dx,620h
         je        TestEVE2                 ; je ip Trident 620

; ------ karta ViewPoint TC - ip ET4000 629

         mov       ax,CardEVE3
         cmp       dx,629h
         je        TestEVE2                 ; je ip ET4000 629

; ------ karta EVGA - ip Trident 673

         mov       ax,CardEVE4
         cmp       dx,673h
         je        TestEVE2                 ; je ip Trident 673

; ------ karta VidewPoint TC - ip Trident 678

         mov       ax,CardEVE5
         cmp       dx,678h
         je        TestEVE2                 ; je ip Trident 678

; ------ jinak standardn ip Everex SuperVGA

         mov       ax,CardEVER              ; bn ip Everex SuperVGA

; ------ detekce velikosti videopamti

TestEVE2:mov       cl,6                     ; poet rotac
         shr       ch,cl                    ; velikost pamti
         mov       cl,ch                    ; CL <- velikost videopamti
         mov       bx,256                   ; velikost videopamti 256 KB
         shl       bx,cl                    ; velikost videopamti v KB
         clc                                ; pznak platnosti karty
TestEVE9:ret

TestEVER ENDP

; *****************************************************************************
;                                 TestAheA
;                       test karty Ahead A/B SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Ahead A/B SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestAheA PROC      NEAR

; ------ schova registru povolen rozenho mdu registr -> CH

         mov       dx,3ceh
         mov       ah,0fh                   ; index registru
         call      ReadIPrt                 ; ten registru
         mov       ch,al                    ; CH <- schova registru

; ------ zkaz rozenho mdu registr

         mov       al,0                     ; zapisovan hodnota
         call      WritIPrt                 ; povolen rozenho mdu

; ------ test registru volby banky (nesm bt zapisovateln)

         mov       ax,0dh*HI + 0ffh         ; AH <- registr, AL <- maska
         call      TestIPrt                 ; test registru volby banky
         cmc
         jc        TestAhe2                 ; lze zapisovat - nen Ahead A/B

; ------ povolen rozenho mdu registr

         mov       ax,0fh*HI + bit5         ; AH <- registr, AL <- hodnota
         call      WritIPrt                 ; povolen rozenho mdu

; ------ test, zda ji lze zapisovat do registru volby banky

         mov       ax,0dh*HI + 0ffh         ; AH <- registr, AL <- maska
         call      TestIPrt                 ; test registru volby banky

; ------ nvrat registru povolen rozenho mdu

TestAhe2:pushf
         mov       ah,0fh                   ; registr
         mov       al,ch                    ; pvodn hodnota
         call      WritIPrt                 ; nvrat obsahu registru
         popf
         jc        TestAhe9                 ; nen Ahead A/B SuperVGA

; ------ nastaven videomdu 640x480/256

         push      ax
         mov       ax,60h
         call      Int10P                   ; nastaven videomdu 640x480/256
         pop       ax

; ------ je karta Ahead A/B SuperVGA - upesnn typu a detekce velikosti pamti

         test      al,bit0+bit1+bit2+bit3   ; je karta Ahead A SuperVGA ?
         mov       ax,CardAHEA              ; karta Ahead A SuperVGA
         mov       bx,512                   ; maximln 512 KB pamti
         mov       dx,offset BankAheA       ; pepnn banky Ahead A SuperVGA
         jz        TestAhe4                 ; je Ahead A SuperVGA
         mov       ax,CardAHEB              ; jinak je Ahead B SuperVGA
         shl       bx,1                     ; maximln 1 MB pamti
         mov       dx,offset BankAheB       ; pepnn banky Ahead B SuperVGA
TestAhe4:call      TestMem                  ; test velikosti videopamti
                                           ;* zde je CY=chyba pamti
TestAhe9:ret

TestAheA ENDP

; *****************************************************************************
;                                 TestCirr
;                       test karty Cirrus 54xx SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Cirrus 54xx SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestCirr PROC      NEAR

; ------ schova registru povolen rozenho mdu registr -> CH

         mov       dx,3c4h
         mov       ah,6                     ; index registru
         call      ReadIPrt                 ; ten registru
         mov       ch,al                    ; CH <- schova registru

; ------ povolen rozenho mdu registr

         mov       ax,6*HI + bit1+bit4      ; AH <- index, AL <- hodnota
         call      WritIPrt                 ; povolen rozenho mdu

; ------ oven zapsan hodnoty

         call      ReadIPrt                 ; zptn naten zapsan hodnoty
         cmp       al,bit1+bit4             ; je pvodn hodnota ?
         stc                                ; pznak chyby
         jne       TestCir9                 ; chyba - nen Cirrus 54xx SuperVGA

; ------ test registru 1Eh

         mov       ax,1Eh*HI + 3Fh          ; AH <- registr, AL <- maska
         call      TestIPrt                 ; test registru
         jc        TestCir9                 ; nen Cirrus 54xx SuperVGA

; ------ test registru 1Bh portu 3D4h

         mov       dl,0d4h                  ; port 3D4h
         mov       ax,1Bh*HI + 0ffh         ; AH <- registr, AL <- maska
         call      TestIPrt                 ; test registru
         jc        TestCir9                 ; nen Cirrus 54xx SuperVGA

; ------ detekce velikosti videopamti

         mov       dl,0c4h                  ; port 3C4h
         mov       ah,0fh                   ; registr
         call      ReadIPrt                 ; ten registru
         shr       al,1
         shr       al,1
         shr       al,1                     ; rotace na pozici
         and       al,bit0+bit1             ; maskovn bit velikosti pamti
         mov       cl,al                    ; CL <- velikost pamti
         mov       bx,256                   ; velikost pamti 256 KB
         shl       bx,cl                    ; vpoet velikosti videopamti
         clc                                ; pznak operace OK

; ------ nvrat registru povolen rozenho mdu registr

TestCir9:pushf
         mov       dl,0c4h
         mov       ah,6
         mov       al,ch                    ; AL <- uschovan hodnota
         call      WritIPrt                 ; nvrat hodnoty registru
         popf
         mov       ax,CardCirr              ; identifiktor karty
         ret

TestCirr ENDP

; *****************************************************************************
;                                 TestAcum
;                       test karty AcuMos SuperVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta AcuMos SuperVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestAcum PROC      NEAR

; ------ schova registru povolen rozenho mdu registr -> CH

         mov       dx,3c4h
         mov       ah,6                     ; index registru
         call      ReadIPrt                 ; ten registru
         mov       ch,al                    ; CH <- schova registru

; ------ povolen rozenho mdu registr

         mov       ax,6*HI + 10010b         ; AH <- index, AL <- hodnota
         call      WritIPrt                 ; povolen rozenho mdu

; ------ test registru 9

         mov       dl,0ceh                  ; port 3CEh
         mov       ax,9*HI + 110000b        ; AH <- index, AL <- maska
         call      TestIPrt                 ; test portu
         jc        TestAcu9                 ; nen to karta AcuMos SuperVGA

; ------ detekce velikosti videopamti

         mov       ah,0ah
         mov       dl,0c4h                  ; port 3C4h
         call      ReadIPrt                 ; ten registru pamti
         and       al,bit0+bit1             ; platn bity
         mov       cl,al                    ; CL <- platn bity
         mov       bx,256                   ; velikost pamti 256 KB
         shl       bx,cl                    ; velikost pamti v KB
         clc

; ------ nvrat registru povolen rozenho mdu registr

TestAcu9:pushf
         mov       dl,0c4h
         mov       ah,6
         mov       al,ch                    ; AL <- uschovan hodnota
         call      WritIPrt                 ; nvrat hodnoty registru
         popf
         mov       ax,CardACUM              ; identifiktor karty
         ret

TestAcum ENDP

; *****************************************************************************
;                                 TestOAK
;                       test karty OAK Technologies SVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta OAK Technologies SVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestOAK  PROC      NEAR

         mov       bx,256                   ; velikost videopamti 256 KB

; ------ test registru velikosti videopamti

         mov       dx,3deh
         mov       ax,0dh*HI + 111000b      ; AH <- index, AL <- maska
         call      TestIPrt                 ; test portu
         jc        TestOAK9                 ; nen karta OAK Technologies SVGA

; ------ test ipu OTI-037C (registr pepnn bank je R/O)

         mov       ch,0
         mov       ax,11h*HI + 0ffh         ; AH <- index, AL <- maska
         call      TestIPrt                 ; test portu
         jnc       TestOAK3                 ; lze zapisovat - nen OTI-037C

; ------ detekce velikosti videopamti pro ip OTI-037C

         mov       ah,0dh
         call      ReadIPrt                 ; ten registru velikosti pamti
         test      al,bit6+bit7             ; je velikost pamti 256 KB ?
         mov       ax,CardOAK               ; identifiktor ipu OTI-037C
         jz        TestOAK8                 ; je 256 KB pamti
         shl       bx,1                     ; jinak 512 KB pamti
         jmp       short TestOAK8

; ------ detekce velikosti videopamti pro ipy OTI-077 a OTI-067

TestOAK3:mov       ah,0dh
         call      ReadIPrt                 ; ten registru velikosti pamti
         mov       cl,6
         shr       al,cl                    ; rotace bit na pozici
         jz        TestOAK4                 ; je 256 KB
         shl       bx,1                     ; 512 KB
         cmp       al,2                     ; je 512 KB ?
         jbe       TestOAK4                 ; je 512 KB
         shl       bx,1                     ; jinak je 1 MB

; ------ ten registru sla verze ipu OAK

TestOAK4:mov       ah,0bh                   ; index
         call      ReadIPrt                 ; ten registru verze
         mov       cl,5                     ; poet rotac
         shr       al,cl                    ; rotace na pozici

; ------ rozlien typu ipu OAK

         cmp       al,5                     ; je OTI-077 ?
         mov       ax,CardOAK1              ; typ OTI-067
         jne       TestOAK8                 ; je typ OTI-067
         mov       ax,CardOAK2              ; typ OTI-077
TestOAK8:clc                                ; pznak karty OAK
TestOAK9:ret

TestOAK  ENDP

; *****************************************************************************
;                                 TestADVL
;                       test karty Advance Logic 2101 SVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta Advance Logic 2101 SVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestADVL PROC      NEAR

; ------ test registru potenho bodu LOW

         mov       dx,8286h                 ; port
         mov       al,0ffh                  ; maska
         call      TestPort                 ; test registr potenho bodu LOW
         jc        TestADV9                 ; nen Advance Logic 2101 SVGA

; ------ test emulanho registru

         mov       dx,3D4h                  ; port
         mov       ax,1fh*HI + 111011b      ; AH <- registr, AL <- maska
         call      TestIPrt                 ; test registru
         jc        TestAdv9                 ; nen Advance Logic 2101 SVGA

; ------ test registru barevn vpln

         mov       ax,0dh*HI + 1111b        ; AH <- registr, AL <- maska
         call      TestIPrt                 ; test registru
         jc        TestAdv9                 ; nen Advance Logic 2101 SVGA

; ------ ten registru velikosti pamti

         mov       ah,1eh                   ; registr velikosti pamti
         call      ReadIPrt                 ; ten registru velikosti pamti
         and       al,3                     ; velikost pamti

; ------ velikost pamti

         xchg      ax,cx                    ; CL <- velikost pamti 0,1,2,3
         mov       bx,256                   ; 256 KB videopamti
         shl       bx,cl                    ; vpoet velikosti videopamti

; ------ je karta Advance Logic 2101 SVGA

         mov       ax,CardADVL              ; identifiktor karty
         clc                                ; pznak operace OK
TestADV9:ret

TestADVL ENDP

; *****************************************************************************
;                                 TestMXIC
;                        test karty MXIC 68010 SVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta MXIC 68010 SVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestMXIC PROC      NEAR

; ------ schova registru povolen rozenho mdu registr -> CL

         mov       dx,3c4h
         mov       ah,0a7h                  ; index registru
         call      ReadIPrt                 ; ten registru
         mov       cl,al                    ; CL <- schova registru

; ------ zkaz rozenho mdu registr

         mov       al,0                     ; md zakzn
         call      WritIPrt                 ; zkaz rozenho mdu

; ------ test registru pepnn bank (pi zkazu nesm bt funkn)

         mov       ax,0c5h*HI + 0ffh        ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru
         cmc                                ; registr nesm bt funkn
         jc        TestMXI3                 ; nen MXIC 68010 SVGA

; ------ povolen rozenho mdu registr

         mov       ax,0a7h*HI + 87h         ; md povolen
         call      WritIPrt                 ; povolen rozenho mdu

; ------ test registru pepnn bank (te u mus bt funkn)

         mov       ax,0c5h*HI + 0ffh        ; AH <- index, AL <- maska
         call      TestIPrt                 ; test registru

; ------ nvrat pvodnho obsahu registru rozenho mdu

TestMXI3:pushf
         xchg      ax,cx                    ; AL <- pvodn hodnota registru
         mov       ah,0a7h                  ; index registru
         call      WritIPrt                 ; nvrat hodnoty registru
         popf
         jc        TestMXI9                 ; nen MXIC 68010 SVGA

; ------ ten registru velikosti pamti

         mov       ah,0c2h                  ; registr velikosti pamti
         call      ReadIPrt                 ; ten registru velikosti pamti
         shr       al,1
         shr       al,1                     ; rotace bit na pozici
         and       al,3                     ; velikost pamti

; ------ velikost pamti

         xchg      ax,cx                    ; CL <- velikost pamti 0,1,2,3
         mov       bx,256                   ; 256 KB videopamti
         shl       bx,cl                    ; vpoet velikosti videopamti

; ------ karta detekovna OK

         mov       ax,CardMXIC              ; identifiktor karty
         clc                                ; pznak platnosti karty
TestMXI9:ret

TestMXIC ENDP

; *****************************************************************************
;                                 TestPrim
;                        test karty Primus 2000 SVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta RealTek 3106 SVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestPrim PROC      NEAR

; ------ test stavovho povelovho registru

         mov       dx,3ceh
         mov       ax,3Dh*HI + 3Fh          ; AH <- stavov registr, AL <- maska
         call      TestIPrt                 ; test registru
         jc        TestPrm9                 ; nen Primus 2000

; ------ test registru zmny banky 1

         mov       dl,0d6h                  ; adresa registru (3D6h)
         mov       al,bit0+bit1+bit2+bit3+bit4 ; maska
         call      TestPort                 ; test registru
         jc        TestPrm9                 ; nen RealTek 3106

; ------ test registru zmny banky 2

         inc       dx                       ; adresa registru (3D7h)
         call      TestPort                 ; test registru (maska = 0fh)
         jc        TestPrm9                 ; nen RealTek 3106

; ------ nastaven videomdu 640x480/256

         mov       ax,2ch
         call      Int10P                   ; nastaven videomdu 640x480/256

; ------ test velikosti pamti

         mov       bx,2048                  ; maximln 2 MB pamti
         mov       dx,offset BankPrim       ; pepnn banky Primus 2000
         call      TestMem                  ; test velikosti videopamti
         jc        TestPrm9                 ; chyba pamti

; ------ karta detekovna OK

TestPrm8:mov       ax,CardPRIM              ; je karta Primus 2000 SVGA
         clc
TestPrm9:ret

TestPrim ENDP

; *****************************************************************************
;                                 TestRT3
;                        test karty RealTek 3106 SVGA
; -----------------------------------------------------------------------------
; VSTUP: CY=nen karta RealTek 3106 SVGA
;         AX=identifiktor karty
;         BX=velikost videopamti (v KB)
; *****************************************************************************

TestRT3  PROC      NEAR

; ------ test emulanho registru

         mov       dx,3D4h                  ; bzov adresa port
         mov       ax,1fh*HI + bit0+bit1    ; registr 1fh, maska bit0+bit1
         call      TestIPrt                 ; test registru emulace
         jc        TestRT39                 ; nen RealTek 3106

; ------ test registru zmny banky 1

         mov       dl,0d6h                  ; adresa registru (3D6h)
         mov       al,bit0+bit1+bit2+bit3   ; maska
         call      TestPort                 ; test registru
         jc        TestRT39                 ; nen RealTek 3106

; ------ test registru zmny banky 2

         inc       dx                       ; adresa registru (3D7h)
         call      TestPort                 ; test registru (maska = 0fh)
         jc        TestRT39                 ; nen RealTek 3106

; ------ naten identifikanho sla ipu

         mov       dl,0d4h                  ; bzov adresa port 3d4h
         mov       ah,1ah                   ; registr
         call      ReadIPrt                 ; ten sla ipu - vy 2 bity
         mov       cl,6                     ; poet rotac
         shr       al,cl                    ; rotace bit na pozici 0 a 1
         mov       ah,0
         xchg      ax,cx                    ; CL <- schova sla ipu HIGH

; ------ naten velikosti pamti

         mov       ah,1eh
         call      ReadIPrt                 ; ten velikosti pamti
         and       al,bit0+bit1+bit2+bit3   ; velikost pamti

; ------ je 256 KB pamti

         mov       bx,256                   ; 256 KB videopamti
         jz        TestRT38                 ; je 256 KB pamti

; ------ 512 KB pamti

         shl       bx,1                     ; 512 KB videopamti
         cmp       al,1
         je        TestRT38                 ; 1 = je 512 KB pamti

; ------ test, zda je verze videokarty 0

         jcxz      TestRT36                 ; je verze karty 0
         shl       bx,1                     ; 1 MB pamti

; ------ 1 MB pamti pro verzi 0, 2 MB pamti pro vy verzi

TestRT36:cmp       al,3                     ; je 1 MB (2 MB) pamti ?
         jb        TestRT38                 ; je 512 KB (1 MB) pamti
         shl       bx,1                     ; pam * 2

TestRT38:mov       ax,CardReal              ; identifiktor karty
         clc                                ; pznak karty RealTek 3106 SVGA
TestRT39:ret

TestRT3  ENDP

;; *****************************************************************************
;;                               Test6845
;;                            test ipu 6845
;;     Test spov v zpisu a ten registru 0Fh ipu (pozice kurzoru LOW).
;;                  Naten hodnota mus bt stejn jako zapsan.
;; -----------------------------------------------------------------------------
;; VSTUP: DX=bzov adresa adie CRTC
;; VSTUP: CY=nen ip 6845
;;         zakazuje peruen !
;; *****************************************************************************
;
;Test6845 PROC      NEAR
;
;         push      ax
;         mov       ax,0fh*HI + 0ffh         ; AL <- maska, AH <- registr
;         call      TestIPrt                 ; test portu
;         pop       ax
;         ret
;
;Test6845 ENDP
;
; *****************************************************************************
;                                  TestMem
;     test velikosti videopamti pro aktuln nastaven videomd 256 barev
; -----------------------------------------------------------------------------
; VSTUP: BX=maximln velikost videopamti v KB (64, 128, 256, 512, 1024,...)
;        DX=adresa obsluhy volby banky (slo banky v registru AL)
; VSTUP: BX=skuten hodnota velikosti videopamti v KB (pi chyb je BX=0)
;         CY=nen videopam (chybn videomd, velikost = 0 KB)
; *****************************************************************************

TestMem  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      es
         mov       bp,dx                    ; BP <- adresa obsluhy volby banky

; ------ pprava adresy ve videopamti -> ES:DI

         mov       ax,0a000h
         mov       es,ax                    ; ES <- segment videopamti
         xor       di,di                    ; DI <- 0 offset ve videopamti

; ------ nastaven posledn banky 64 KB

TestMem2:mov       ax,bx                    ; aktuln velikost videopamti
         mov       cl,6                     ; poet rotac
         shr       ax,cl                    ; pepoet na poet bank 64 KB
         dec       ax                       ; slo posledn banky
         call      bp                       ; volba poadovan banky
         xchg      ax,cx                    ; CX <- schova sla banky

; ------ zmna obsahu videopamti

         mov       ax,es:[di]               ; aktuln obsah videopamti
         mov       dx,ax                    ; DX <- schova obsahu videpamti
         xor       ax,5aa5h                 ; zmna vzorku
         mov       es:[di],ax               ; uloen zmnnho vzorku
         jmp       short $+2
         jmp       short $+2                ; mal prodleva

; ------ test vzorku videopamti

         mov       ax,es:[di]               ; nov obsah videopamti
         mov       es:[di],dx               ; nvrat obsahu videopamti
         xor       ax,5aa5h                 ; nvrat pvodn hodnoty
         cmp       ax,dx                    ; je obsah videopamti platn ?
         jne       TestMem7                 ; nen platn - snen velikosti

; ------ nastaven posledn banky 64 KB v polovin detekovan pamti

         mov       ax,cx                    ; AX <- slo posledn banky
         inc       ax                       ; poet bank 64 KB
         shr       ax,1                     ; polovina videopamti
         clc                                ; pznak operace OK
         jz        TestMem8                 ; je to ji posledn banka 64 KB
         dec       ax                       ; banka v polovin pamti
         call      bp                       ; volba poadovan banky
         xchg      ax,si                    ; SI <- schova banky poloviny

; ------ zpis negovanho vzorku do poloviny pamti

         mov       ax,es:[di]               ; schova pvodnho obsahu
         push      dx
         xor       dx,0a56dh                ; asi takov vzorek
         mov       es:[di],dx               ; zpis negovanho vzorku
         pop       dx

; ------ nastaven posledn banky

         xchg      ax,cx                    ; AX <- posledn banka, CX <- hodnota
         call      bp                       ; volba posledn banky

; ------ test, zda byl zmnn obsah posledn banky

         mov       ax,es:[di]               ; aktuln hodnota
         cmp       ax,dx                    ; byla hodnota zmnna ?

; ------ nvrat pvodnho obsahu v polovin

         pushf
         xchg      ax,si                    ; slo banky v polovin
         call      bp                       ; volba banky v polovin
         mov       es:[di],cx               ; nvrat pvodnho obsahu
         popf
         je        TestMem8                 ; hodnota se nezmnila - to je OK

; ------ chyba - snen velikosti videopamti

TestMem7:shr       bx,1                     ; snen velikosti videopamti
         cmp       bx,64                    ; je jet velikost OK ?
         jae       TestMem2                 ; velikost je jet OK
         xor       bx,bx                    ; chyba - nen videopam
         stc                                ; pznak chyby

; ------ nvrat registr

TestMem8:pop       es
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

TestMem  ENDP

; 
;
;                          Pepnn bank
;
; 
;
; *****************************************************************************
;                                BankNCR
;                       volba banky karty NCR 77C22E
; -----------------------------------------------------------------------------
; VSTUP: AL=slo banky
; *****************************************************************************

BankNCR  PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

; ------ zmna banky 64 KB na 16 KB

         shl       al,1
         shl       al,1                     ; zmna na slovn po 16 KB
         mov       ah,al                    ; AH <- schova sla banky

; ------ nastaven sla banky pro zpis

         mov       dx,3c4h
         mov       al,18h
         out       dx,al                    ; index registru zpisov banky
         inc       dx
         mov       al,ah                    ; AL <- slo banky
         out       dx,al                    ; nastaven banky pro zpis

; ------ nastaven sla banky pro ten

         dec       dx                       ; port 3C4h
         mov       al,1ch
         out       dx,al                    ; index registru tec banky
         inc       dx
         mov       al,ah                    ; AL <- slo banky
         out       dx,al                    ; nastaven banky pro ten

; ------ nvrat registr

         pop       dx
         pop       ax
         ret

BankNCR  ENDP

; *****************************************************************************
;                              BankET30
;                      volba banky karty ET3000
; -----------------------------------------------------------------------------
; VSTUP: AL=slo banky
; *****************************************************************************

BankET30 PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

; ------ pprava dat pro volbu banky

         mov       ah,al                    ; poadovan banka
         shl       al,1
         shl       al,1
         shl       al,1
         or        al,ah
         or        al,bit6                  ; volba segment 64 KB
         mov       dx,3cdh
         out       dx,al                    ; volba poadovan banky

; ------ nvrat registr

         pop       dx
         pop       ax
         ret

BankET30 ENDP

; *****************************************************************************
;                               BankAheA
;                     volba banky karty Ahead A
; -----------------------------------------------------------------------------
; VSTUP: AL=slo banky
; *****************************************************************************

BankAheA PROC      NEAR

; ------ schova registr

         push      ax
         push      dx
         mov       ah,al                    ; schova sla banky

; ------ ten registru "Misc Output"

         mov       dx,3cch
         in        al,dx                    ; ten registru "Misc Output"

; ------ nastaven bitu 0 sla banky

         mov       dl,0c2h                  ; port 3C2h
         and       al,not bit5              ; nulovn bitu 0 sla banky
         shr       ah,1                     ; m bt bit nastaven ?
         jnc       BankAhA2                 ; bit nem bt nastaven
         or        al,bit5                  ; nastaven bitu 0 sla banky
BankAhA2:out       dx,al                    ; nastaven nov hodnoty bitu 0

; ------ nastaven bit 1 a 3 sla banky

         mov       dl,0ceh                  ; port 3CEh
         mov       al,0dh
         out       dx,al                    ; volba registru sla banky
         inc       dx
         mov       al,ah                    ; slo banky - bity 1 a 3
         out       dx,al                    ; nastaven bit 1 a 3 sla banky

; ------ nvrat registr

         pop       dx
         pop       ax
         ret

BankAheA ENDP

; *****************************************************************************
;                               BankAheB
;                     volba banky karty Ahead B
; -----------------------------------------------------------------------------
; VSTUP: AL=slo banky
; *****************************************************************************

BankAheB PROC      NEAR

; ------ schova registr

         push      ax
         push      dx

; ------ pprava dat pro volbu banky

         mov       ah,al                    ; poadovan banka
         shl       al,1
         shl       al,1
         shl       al,1
         shl       al,1
         or        ah,al

; ------ volba registru volby banky

         mov       al,0dh                   ; index registru volby banky
         mov       dx,3ceh
         out       dx,al                    ; volba registru pepnae banky

; ------ nastaven poadovan banky

         inc       dx                       ; data 3CFh
         mov       al,ah                    ; poadovan banka
         out       dx,al                    ; volba poadovan banky

; ------ nvrat registr

         pop       dx
         pop       ax
         ret

BankAheB ENDP

; *****************************************************************************
;                              BankPrim
;                    volba banky karty Primus 2000
; -----------------------------------------------------------------------------
; VSTUP: AL=slo banky
; *****************************************************************************

BankPrim PROC      NEAR

         push      dx

         mov       dx,3d6h
         out       dx,al                    ; volba banky pro ten
         inc       dx
         out       dx,al                    ; volba banky pro zpis

         pop       dx
         ret

BankPrim ENDP

; 
;
;                       Univerzln obsluhy port
;
; 
;
; *****************************************************************************
;                              TestIPrt
;            test bit indexovanho portu tenm a zpisem
; -----------------------------------------------------------------------------
; VSTUP: DX=bzov adresa portu (tj. adresa index)
;        AL=maska (testovan bity = 1)
;        AH=index (slo registru)
; VSTUP: CY=neodpovd
; *****************************************************************************

TestIPrt PROC      NEAR

; ------ schova registr

         push      bx

; ------ schova nastavenho indexu

         xchg      ax,bx                    ; BX <- mezischova registr
         in        al,dx                    ; naten aktulnho sla registru
         xchg      ax,bx                    ; BL <- schova sla registru

; ------ nastaven poadovanho indexu

         xchg      al,ah                    ; AL <- slo indexu
         out       dx,al                    ; nastaven poadovanho registru
         xchg      al,ah

; ------ test portu

         inc       dx                       ; data registru
         call      TestPort                 ; test portu
         dec       dx                       ; nvrat adresy indexu

; ------ nvrat pvodnho indexu

         xchg      ax,bx                    ; AL <- pvodn nastaven index
         out       dx,al                    ; nvrat pvodnho indexu
         xchg      ax,bx

; ------ nvrat registr

         pop       bx
         ret

TestIPrt ENDP

; *****************************************************************************
;                               TestPort
;          test bit portu tenm a zpisem (ten mus odpovdat zpisu)
; -----------------------------------------------------------------------------
; VSTUP: DX=adresa portu
;        AL=maska (testovan bity = 1)
; VSTUP: CY=neodpovd
; *****************************************************************************

TestPort PROC      NEAR

; ------ schova registr

         push      ax
         push      bx

; ------ pprava masky -> BX

         mov       bl,al                    ; BL <- maska bit k testovn
         not       al                       ; negace masky
         mov       bh,al                    ; BH <- negovan maska bit k testu

; ------ schova pvodnho obsahu portu -> AH

         in        al,dx                    ; naten pvodnho obsahu portu
         mov       ah,al                    ; AH <- schova pvodnho obsahu portu

; ------ zpis vzorku 1 - testovan bity jsou vynulovny

         and       al,bh                    ; vynulovn testovanch bit
         out       dx,al                    ; zpis vzorku 1 - vynulovan bity

; ------ mal prodleva

         jmp       short $+2
         jmp       short $+2
         jmp       short $+2

; ------ test vzorku 1 - testovan bity mus bt vynulovan

         in        al,dx                    ; naten novho stavu portu
         and       al,bl                    ; maskovn testovanch bit
         jnz       TestPrt8                 ; chyba - bity nejsou platn

; ------ zpis vzorku 2 - testovan bity jsou nastaveny

         mov       al,ah                    ; AL <- pvodn obsah portu
         or        al,bl                    ; nastaven testovanch bit
         out       dx,al                    ; zpis vzorku 2 - nastaven bity

; ------ mal prodleva

         jmp       short $+2
         jmp       short $+2
         jmp       short $+2

; ------ test vzorku 2 - testovan bity mus bt nastaven

         in        al,dx                    ; nastaven novho stavu portu
         and       al,bl                    ; maskovn testovanch bit
         cmp       al,bl                    ; jsou bity nastaven ?
         je        TestPrt9                 ; bity jsou platn OK
TestPrt8:stc                                ; pznak chyby - port neplatn

; ------ nvrat pvodnho obsahu portu

TestPrt9:mov       al,ah                    ; AL <- pvodn obsah portu
         out       dx,al                    ; nvrat pvodnho obsahu portu

; ------ nvrat registr

         pop       bx
         pop       ax
         ret

TestPort ENDP

; *****************************************************************************
;                                ReadIPrt
;                       ten indexovanho portu
; -----------------------------------------------------------------------------
; VSTUP: DX=bzov adresa portu (tj. adresa index)
;        AH=index (slo registru)
; VSTUP: AL=naten bajt
; *****************************************************************************

ReadIPrt PROC      NEAR

; ------ schova registr

         push      bx

; ------ schova pvodnho nastaven registru -> BL

         in        al,dx                    ; naten registru
         mov       bl,al                    ; BL <- schova sla registru

; ------ nastaven poadovanho sla registru

         mov       al,ah                    ; AL <- slo registru
         out       dx,al                    ; nastaven poadovanho registru

; ------ naten hodnoty z registru -> AL

         inc       dx                       ; datov port
         in        al,dx                    ; naten dat z registru
         dec       dx                       ; nvrat adresy portu

; ------ nvrat pvodn nastavenho registru

         xchg      al,bl                    ; AL <- pvodn hodnota, BL <- data
         out       dx,al                    ; nvrat sla registru
         mov       al,bl                    ; AL <- naten data

; ------ nvrat registr

         pop       bx
         ret

ReadIPrt ENDP

; *****************************************************************************
;                                 WritIPrt
;                       zpis do indexovanho portu
; -----------------------------------------------------------------------------
; VSTUP: DX=bzov adresa portu (tj. adresa index)
;        AH=index (slo registru)
;        AL=hodnota k zpisu
; *****************************************************************************

WritIPrt PROC      NEAR

; ------ schova registr

         push      bx

; ------ schova pvodnho nastaven registru -> BL

         xchg      ax,bx                    ; BX <- schova AX
         in        al,dx                    ; naten registru
         xchg      ax,bx                    ; BL <- schova registru, nvrat AX

; ------ nastaven poadovanho sla registru

         xchg      al,ah                    ; AL <- slo registru
         out       dx,al                    ; nastaven poadovanho registru
         xchg      al,ah

; ------ zpis hodnoty do registru

         inc       dx                       ; datov port
         out       dx,al                    ; zpis dat do registru
         dec       dx                       ; nvrat adresy portu

; ------ nvrat pvodn nastavenho registru

         xchg      ax,bx                    ; AL <- pvodn hodnota, BL <- data
         out       dx,al                    ; nvrat sla registru
         xchg      ax,bx                    ; nvrat AX

; ------ nvrat registr

         pop       bx
         ret

WritIPrt ENDP

; 
;
;                      Tabulka definic videokaret
;
; 
;
TDefCard label     byte

         dw        _NUL
         db        3,'???'
         db        0
         dw        0
_NUL:

         dw        _CGA
         db        3,'CGA'
         db        0
         dw        0
_CGA:

         dw        _MCGA
         db        4,'MCGA'
         db        0
         dw        0
_MCGA:

         dw        _EGA
         db        3,'EGA'
         db        0
         dw        0
_EGA:

         dw        _EGA64
         db        9,'EGA 64 KB'
         db        0
         dw        0
_EGA64:

         dw        _EGAM
         db        8,'EGA Mono'
         db        0
         dw        0
_EGAM:

         dw        _EGA6M
         db        14,'EGA 64 KB Mono'
         db        0
         dw        0
_EGA6M:

         dw        _Herc
         db        8,'Hercules'
         db        0
         dw        0
_Herc:

         dw        _VGA
         db        3,'VGA'
         db        0
         dw        0
_VGA:

         dw        _VESA
         db        13,'VESA SuperVGA'
         db        0
         dw        TestVESA
_VESA:

         dw        _ACUM
         db        15,'Acumos SuperVGA'
         db        6,'ACUMOS'
         dw        TestAcum
_ACUM:

         dw        _ADVL
         db        29,'Advance Logic AL2101 SuperVGA'
         db        13,'ADVANCE LOGIC'
         dw        TestADVL
_ADVL:

         dw        _AHEA
         db        16,'AHEAD A SuperVGA'
         db        5,'AHEAD'
         dw        TestAheA
_AHEA:

         dw        _AHEB
         db        16,'AHEAD B SuperVGA'
         db        5,'AHEAD'
         dw        TestAheA
_AHEB:

         dw        _ATI
         db        31,'ATI Technologies SuperVGA 18800'
         db        5,'ATI S'
         dw        TestATI
_ATI:

         dw        _ATI1
         db        33,'ATI Technologies SuperVGA 18800-1'
         db        8,'ATI PRIS'
         dw        TestATI
_ATI1:

         dw        _ATI2
         db        33,'ATI Technologies SuperVGA 28800-2'
         db        7,'ATI VGA'
         dw        TestATI
_ATI2:

         dw        _ATI4
         db        33,'ATI Technologies SuperVGA 28800-4'
         db        7,'ATI VIP'
         dw        TestATI
_ATI4:

         dw        _ATI5
         db        33,'ATI Technologies SuperVGA 28800-5'
         db        7,'ATI EGA'
         dw        TestATI
_ATI5:

         dw        _CHIP
         db        46,'Chips & Technologies SVGA 82c451,82c455,82c456'
         db        5,'CHIPS'
         dw        TestCHIP
_CHIP:

         dw        _CHI1
         db        32,'Chips & Technologies SVGA 82c452'
         db        5,'CHIPS'
         dw        TestCHIP
_CHI1:

         dw        _CHI2
         db        32,'Chips & Technologies SVGA 82c453'
         db        5,'CHIPS'
         dw        TestCHIP
_CHI2:

         dw        _Cirr
         db        20,'Cirrus 5422 SuperVGA'
         db        6,'CIRRUS'
         dw        TestCirr
_Cirr:

         dw        _EVER
         db        15,'Everex SuperVGA'
         db        6,'EVEREX'
         dw        TestEVER
_EVER:

         dw        _EVE1
         db        35,'UltraGraphics Ev236 Everex SuperVGA'
         db        9,'ULTRAGRAP'
         dw        TestEVER
_EVE1:

         dw        _EVE2
         db        32,'Vision VGA Ev620 Everex SuperVGA'
         db        6,'VISION'
         dw        TestEVER
_EVE2:

         dw        _EVE3
         db        34,'ViewPoint TC Ev629 Everex SuperVGA'
         db        9,'VIEWPOINT'
         dw        TestEVER
_EVE3:

         dw        _EVE4
         db        26,'EVGA Ev673 Everex SuperVGA'
         db        4,'EVGA'
         dw        TestEVER
_EVE4:

         dw        _EVE5
         db        34,'ViewPoint TC Ev678 Everex SuperVGA'
         db        9,'VIEWPOINT'
         dw        TestEVER
_EVE5:

         dw        _GEN1
         db        32,'Genoa Systems SuperVGA GVGA 6100'
         db        5,'GENOA'
         dw        TestGENO
_GEN1:

         dw        _GEN2
         db        34,'Genoa Systems SuperVGA GVGA 62/300'
         db        5,'GENOA'
         dw        TestGENO
_GEN2:

         dw        _GEN4
         db        34,'Genoa Systems SuperVGA GVGA 64/600'
         db        5,'GENOA'
         dw        TestGENO
_GEN4:

         dw        _MXIC
         db        19,'MXIC 68010 SuperVGA'
         db        4,'MXIC'
         dw        TestMXIC
_MXIC:

         dw        _NCR0
         db        21,'NCR 77C20/21 SuperVGA'
         db        5,'NCR 7'
         dw        TestNCR
_NCR0:

         dw        _NCR2
         db        19,'NCR 77C22E SuperVGA'
         db        5,'NCR 7'
         dw        TestNCR
_NCR2:

         dw        _OAK
         db        34,'OAK Technologies SuperVGA OTI-037C'
         db        9,'OAK TECHN'
         dw        TestOAK
_OAK:

         dw        _OAK1
         db        33,'OAK Technologies SuperVGA OTI-067'
         db        9,'OAK TECHN'
         dw        TestOAK
_OAK1:

         dw        _OAK2
         db        33,'OAK Technologies SuperVGA OTI-077'
         db        9,'OAK TECHN'
         dw        TestOAK
_OAK2:

         dw        _PAR
         db        24,'Paradise SuperVGA PVGA1A'
         db        8,'PARADISE'
         dw        TestPar
_PAR:

         dw        _PA00
         db        25,'Paradise SuperVGA WD90C00'
         db        7,'WESTERN'
         dw        TestPar
_PA00:

         dw        _PA10
         db        25,'Paradise SuperVGA WD90C10'
         db        7,'WESTERN'
         dw        TestPar
_PA10:

         dw        _PA11
         db        25,'Paradise SuperVGA WD90C11'
         db        7,'WESTERN'
         dw        TestPar
_PA11:

         dw        _PA20
         db        25,'Paradise SuperVGA WD90C20'
         db        7,'WESTERN'
         dw        TestPar
_PA20:

         dw        _PA30
         db        25,'Paradise SuperVGA WD90C30'
         db        7,'WESTERN'
         dw        TestPar
_PA30:

         dw        _PA31
         db        25,'Paradise SuperVGA WD90C31'
         db        7,'WESTERN'
         dw        TestPar
_PA31:

         dw        _PRIM
         db        20,'Primus 2000 SuperVGA'
         db        6,'PRIMUS'
         dw        TestPrim
_PRIM:

         dw        _Real
         db        21,'RealTek 3106 SuperVGA'
         db        7,'REALTEK'
         dw        TestRT3
_Real:

         dw        _S911
         db        18,'S3 SuperVGA 86c911'
         db        6,'86C911'
         dw        TestS3
_S911:

         dw        _S924
         db        18,'S3 SuperVGA 86c924'
         db        6,'86C924'
         dw        TestS3
_S924:

         dw        _S801
         db        25,'S3 SuperVGA 86c801/86c805'
         db        5,'86C80'
         dw        TestS3
_S801:

         dw        _S928
         db        18,'S3 SuperVGA 86c928'
         db        6,'86C928'
         dw        TestS3
_S928:

         dw        _TRI8
         db        21,'Trident 8800 SuperVGA'
         db        7,'TRIDENT'
         dw        TestTri
_TRI8:

         dw        _TRI9
         db        26,'Trident 8900/9000 SuperVGA'
         db        7,'TRIDENT'
         dw        TestTri
_TRI9:

         dw        _ET30
         db        26,'Tseng Labs ET3000 SuperVGA'
         db        5,'TSENG'
         dw        TestET30
_ET30:

         dw        _ET40
         db        36,'MegaEva/2 Tseng Labs ET4000 SuperVGA'
         db        7,'MEGAEVA'
         dw        TestET30
_ET40:

         dw        _ET41
         db        47,'Diamond Speedstar 24 Tseng Labs ET4000 SuperVGA'
         db        7,'DIAMOND'
         dw        TestET30
_ET41:

         dw        _ET42
         db        37,'Genoa 7900 Tseng Labs ET4000 SuperVGA'
         db        5,'GENOA'
         dw        TestET30
_ET42:

         dw        _VID7
         db        15,'Video7 SuperVGA'
         db        6,'VIDEO7'
         dw        TestVID
_VID7:

TDefCrd0 label     byte                     ; konec tabulky

Code     ENDS

; 
;
;                          Datov segment
;
; 
;
Data     SEGMENT   PARA

DataBeg  label     byte                     ; zatek datovho segmentu

; ------ ukazatele parametr aktuln karty

ACardNam dw        0                        ; adresa jmna karty
ACardSrc dw        0                        ; adresa vyhledvacho etzce karty
ACardTst dw        0                        ; adresa obsluhy testu karty

; ------

VParam   db        0                        ; parametry
                                            ;   bit 0: 1=mon pepnn strnek

VDACType dw        DACTyp0                  ; typ DAC registru

CardParm db        0                        ; parametry videokarty
                                            ;    bit 0: 1=kompatibilita CGA
                                            ;    bit 1: 1=kompatibilita Hercules
                                            ;    bit 2: 1=kompatibilita EGA
                                            ;    bit 3: 1=rozhran VESA

;VCard    dw        0                        ; slo videokarty (0=neznm)

VChipID  dw        0                        ; intern identifiktor ipu SVGA
VideoMem dw        256                      ; velikost videopamti (v KB)

VModesN  dw        0                        ; poet obsluhovanch videomd

VModes   label     word                     ; seznam povolench videomd
         dw        100 dup(?)

VesaInfo db        256 dup(?)               ; buffer informanho bloku VESA

Data     ENDS

         END       Start
